class Article {

	static onDOMContentLoaded(f) {
		window.addEventListener("DOMContentLoaded", f, false);
	}

	static init() {
		let imgs = document.querySelectorAll("figure.popping img");
		imgs.forEach((element, index, list) => {
			element.addEventListener("click", Article.enlarge, false);
		});

		let history = document.querySelector("#history > dt");
		if (history) {
			history.addEventListener("click", Article.toggleHistory, false);
		};
	}

	static callAdSense() {
		(adsbygoogle = window.adsbygoogle || []).push({});
	}

	static toggleHistory(event) {
		document.getElementById("history").classList.toggle("all");
	}

	static enlarge(event) {
		let content = event.target;
		Article._createImageFrame(content);
	}

	static _createImageFrame(content) {

		let frame = document.createElement("div");
		frame.id = "PoppingImageFrame";

		let message = document.createElement("div");
		message.innerHTML = "Click or Esc to close";
		frame.appendChild(message);

		let cloned  = content.cloneNode(true);
		frame.appendChild(cloned);

		frame   .addEventListener("click"  , Article._closeImageFrame, false);
		document.addEventListener("keydown", Article._closeImageFrame, false);

		return document.body.appendChild(frame);
	}

	static _closeImageFrame(event) {
		if (event.type == "keydown") {
			switch (event.keyCode) {
			case  9:
			case 13:
			case 27:
			case 32:
				Article._removeImageFrame();
				event.preventDefault();
			}
		} else if (event.type == "click") {
			Article._removeImageFrame();
		}
	}

	static _removeImageFrame() {
		let frame = document.getElementById("PoppingImageFrame");
		if (frame) {
			document.removeEventListener("keydown" , Article._closeImageFrame);
			document.body.removeChild(frame);
		}
	}
}

Article.onDOMContentLoaded(Article.init);
